/*
 * render.c
 *
 * Copyright (c) 1995, John D. Kilburg
 *
 * See copyright.h for more information.
 */
#include "copyright.h"

#include <stdio.h>
#include <ctype.h>

#include <sys/types.h>

#include <X11/IntrinsicP.h>
#include <X11/StringDefs.h>

#include "common.h"
#include "WWWP.h"

void
Render(rw, xe)
WWWWidget rw;
XEvent *xe;
{
  RenderLine *rl;
  RenderPart *rp;
  int rly2;
  Region r;
  int y1, y2;

  if (rw->www.rlhead == NULL) return;

  y1 = xe->xexpose.y;
  y2 = xe->xexpose.y + xe->xexpose.height;

  r = XCreateRegion();
  XtAddExposureToRegion(xe, r);

  for (rl = rw->www.rlhead; rl != NULL; rl = rl->next)
  {
    rly2 = rl->y + rl->height;
    if (rl->y < y1 && rly2 < y1) continue;
    else if (rl->y > y2 && rly2 > y2) return;

    for (rp = rl->rphead; rp != NULL; rp = rp->lnext)
    {
      if (rp->render != NULL && rp->renderable)
      {
	if (XRectInRegion(r, rp->x, rp->y, rp->width, rp->height))
	{
	  (rp->render)(rw, rp, xe);
	}
      }
    }
  }

  XDestroyRegion(r);

  return;
}

