/*
 * gifp.h
 *
 * Created from parts of old gifin.h
 * John Kilburg (john@cs.unlv.edu)
 *
 * gifin.h
 * kirk johnson
 * november 1989
 * external interface to gifin.c
 *
 * Copyright 1989 Kirk L. Johnson (see the included file
 * "kljcpyrght.h" for complete copyright information)
 */

#include "gif.h"

/*
 * gifin return codes
 */
#define GS_SUCCESS       0      /* success */
#define GS_DONE          1      /* no more images */
#define GS_NEED_DATA     2      /* needs more data */
#define GS_NEED_DATA_NOR 3      /* needs more data, no rewind */

#define GS_ERR_BAD_SD   -1      /* bad screen descriptor */
#define GS_ERR_BAD_SEP  -2      /* bad image separator */
#define GS_ERR_BAD_SIG  -3      /* bad signature */
#define GS_ERR_EOD      -4      /* unexpected end of raster data */
#define GS_ERR_EOF      -5      /* unexpected end of input stream */
#define GS_ERR_FAO      -6      /* file already open */
#define GS_ERR_IAO      -7      /* image already open */
#define GS_ERR_NFO      -8      /* no file open */
#define GS_ERR_NIO      -9      /* no image open */
#define GS_ERR_BAD_STATE -10    /* bad state */

/*
 * colormap indices 
 */
#define GIF_RED  0
#define GIF_GRN  1
#define GIF_BLU  2

/*
 * #defines, typedefs, and such
 */
#define GIF_SIG      "GIF87a"
#define GIF_SIG_89   "GIF89a"
#define GIF_SIG_LEN  6          /* GIF signature length */
#define GIF_SD_SIZE  7          /* GIF screen descriptor size */
#define GIF_ID_SIZE  9          /* GIF image descriptor size */

#define GIF_SEPARATOR   ','     /* GIF image separator */
#define GIF_EXTENSION   '!'     /* GIF extension block marker */
#define GIF_TERMINATOR  ';'     /* GIF terminator */

#define NULL_CODE  -1           /* string table null code */

/*
 * GIF states
 */
#define GS_OPEN_FILE 0
#define GS_OPEN_IMAGE 1
#define GS_LOAD_G_CMAP 2
#define GS_LOAD_L_CMAP 4
#define GS_DECODE_DATA 5
#define GS_MAKE_IMAGE 6
#define GS_INIT_DECODER 8
#define GS_READ_SIG 9
#define GS_READ_IMAGE_HEADER 10




